<?php
class Customily_Options_Settings_DB
{
    public $options_table_name = 'options';

    /**
     * Customily_Options_Settings_DB constructor.
     */
    public function __construct()
    {
        global $wpdb;
        $this->options_table_name = "{$wpdb->prefix}{$this->options_table_name}";
    }

    /**
     * @return array
     */
    public function get_store_owner_info()
    {
        global $wpdb;
        $result = [];
        $options = $wpdb->get_results(
            $wpdb->prepare(
                "SELECT option_name, option_value FROM %i" .
                " WHERE option_name = 'woocommerce_email_from_name' OR option_name = 'woocommerce_email_from_address'" .
                " ORDER BY option_name ASC",
                [$this->options_table_name]
            )
        );

        if (count($options) > 0) {
            $result['name'] = !empty($options[1]->option_value) && strlen($options[1]->option_value) > 0
                                ? $options[1]->option_value
                                : 'unknown';
            $result['email'] = !empty($options[0]->option_value) && strlen($options[0]->option_value) > 0
                                ? $options[0]->option_value
                                : 'unknown';
        }
        return $result;
    }
}