<?php
wp_add_inline_script(
    'customily-settings-script',
    '
        const s3BaseUrl = "' . esc_url(CUSTOMILY_OPTIONS_S3_ROOT_URL) . '";
        const previewApiBaseUrl = "' . esc_url(CUSTOMILY_OPTIONS_PREVIEW_API_BASE_URL) . '/status";
        const s3DnsPrefetchLink = document.createElement("link");
        s3DnsPrefetchLink.id = "customily-s3-dns-prefetch";
        s3DnsPrefetchLink.rel = "dns-prefetch";
        s3DnsPrefetchLink.href = s3BaseUrl;
        document.head.appendChild(s3DnsPrefetchLink);
    
        const s3PreConnectLink = document.createElement("link");
        s3PreConnectLink.id = "customily-s3-preconnect"
        s3PreConnectLink.rel = "preconnect";
        s3PreConnectLink.href = s3BaseUrl;
        document.head.appendChild(s3PreConnectLink);
    
        const previewApiDnsPrefetchLink = document.createElement("link");
        previewApiDnsPrefetchLink.id = "customily-preview-api-dns-prefetch"
        previewApiDnsPrefetchLink.rel = "dns-prefetch";
        previewApiDnsPrefetchLink.href = previewApiBaseUrl;
        document.head.appendChild(previewApiDnsPrefetchLink);
    
        const previewApiPreConnectLink = document.createElement("link");
        previewApiPreConnectLink.id = "customily-preview-api-preconnect"
        previewApiPreConnectLink.rel = "preconnect";
        previewApiPreConnectLink.href = previewApiBaseUrl;
        document.head.appendChild(previewApiPreConnectLink);
    
        var buttonDisableInterval = null;
    
        function createCustomEvent(eventName, data = {}) {
            var event;
            if (typeof CustomEvent === "function") {
                event = new CustomEvent(eventName, {detail: data});
            } else {
                event = document.createEvent("CustomEvent");
                event.initCustomEvent(eventName, false, false, data);
            }
            return event;
        }
    
        function disableAddToCartButton() {
            if (customilyWordpress?.buttons?.disabledUntilAppLoad) {
                const maxTime = customilyWordpress.buttons.disableMaximumTime || 30000;
                var t = 0;
    
                buttonDisableInterval = setInterval(function () {
                    if (t > maxTime) {
                        window.dispatchEvent(createCustomEvent("customily-enable-add-to-cart-btn"));
                    }
                    var buttons;
                    if (customilyWordpress.buttons.cartButtonSelector) {
                        buttons = document.getElementsByClassName(customilyWordpress.buttons.cartButtonSelector);
                    } else {
                        buttons = document.getElementsByClassName("single_add_to_cart_button");
                    }
    
                    if (buttons.length) {
                        for (var i = 0; i < buttons.length; i++) {
                            if (!buttons[i].getAttribute("disabled")) {
                                buttons[i].setAttribute("disabled", "disabled");
                            }
                        }
                    }
                    t += 250;
                }, 250);
            }
        }
    
        function enableAddToCartButton() {
            if (customilyWordpress?.buttons?.cartButtonSelector) {
                buttons = document.getElementsByClassName(customilyWordpress.buttons.cartButtonSelector);
            } else {
                buttons = document.getElementsByClassName("single_add_to_cart_button");
            }
            if (buttons.length) {
                for (var i = 0; i < buttons.length; i++) {
                    buttons[i].removeAttribute("disabled");
                }
            }
            clearInterval(buttonDisableInterval);
        }
    
        window.addEventListener("customily-app-load-start", function () {
            if (customilyWordpress) {
                customilyWordpress.appLoading = true;
            }
        });
    
        window.addEventListener("customily-disable-add-to-cart-btn", function () {
            if (customilyWordpress.disableAddToCartButton) {
                customilyWordpress.disableAddToCartButton();
            } else {
                disableAddToCartButton();
            }
        });
    
        window.addEventListener("customily-enable-add-to-cart-btn", function () {
            if (customilyWordpress.enableAddToCartButton) {
                customilyWordpress.enableAddToCartButton();
            } else {
                enableAddToCartButton();
            }
        });

        if (!window.customilyWordpress.priceOptions.disabled) {
            window.addEventListener("customily-options-loaded", function () {
                jQuery(function ($) {
                    const regExp = customilyWordpress.priceOptions.decimalSeparator == ","
                        ? /[+-]?\d+([\,]\d+)?/g
                        : /[+-]?\d+([\,]\d+)*([\.]\d+)?/g;

                    customilyWordpress.priceOptions.getBasePrice = function (container) {
                        container = container || customilyWordpress.priceOptions.originalContainer;
                        var result = false;
                        if (container.length) {
                            var value = $(container).first().text().match(regExp);
                            if (value && value[0]) {
                                result = value[0];
                            }
                        }
                        if (!result) {
                            if (
                                customilyWordpress.product &&
                                customilyWordpress.product.variants &&
                                customilyWordpress.product.variants.length
                            ) {
                                var variant_id = $("input[name=\"variation_id\"]").val();
                                if (!variant_id || variant_id == "0") {
                                    result = customilyWordpress.product.variants[0].price;
                                } else {
                                    var variant = customilyWordpress.product.variants.find(function (v) {
                                        return v.id == variant_id;
                                    });
                                    result = variant ? variant.id : customilyWordpress.product.variants[0].price;
                                }
                            } else {
                                result = customilyWordpress.product
                                    ? customilyWordpress.product.price
                                    : 0.00;
                            }
                        }
                        if (customilyWordpress.priceOptions.decimalSeparator == ",") {
                            result = result.replace(",", ".");
                        }
                        if (
                            customilyWordpress.priceOptions.thousandSeparator &&
                            customilyWordpress.priceOptions.thousandSeparator != "."
                        ) {
                            result = result.replace(customilyWordpress.priceOptions.thousandSeparator, "");
                        }
                        return parseFloat(result).toFixed(parseInt(customilyWordpress.priceOptions.decimalCount));
                    };

                    customilyWordpress.priceOptions.getOriginalContainer = function () {
                        var result = $(".cl-product-page.cl-original-price");

                        if (!result.length) {
                            if (window.customilyWordpress.priceOptions.originalContainer) {
                                result = window.customilyWordpress.priceOptions.originalContainer;
                            } else {
                                if (
                                    customilyWordpress.product &&
                                    customilyWordpress.product.variants &&
                                    customilyWordpress.product.variants.length
                                ) {
                                    result = $(".single_variation_wrap .price ins bdi");
                                    if (!result.length) {
                                        result = $(".single_variation_wrap .price bdi");
                                    }
                                }

                                if (!result || !result.length) {
                                    result = $("form.cart .price ins bdi");
                                }

                                if (!result.length) {
                                    result = $(".summary.entry-summary .price ins bdi");
                                }

                                if (!result.length) {
                                    result = $("form.cart .price bdi");
                                }

                                if (!result.length) {
                                    result = $(".summary.entry-summary .price bdi");
                                }

                                if (!result.length) {
                                    result = $(".price bdi");
                                }
                            }
                        }

                        return result
                    };

                    customilyWordpress.priceOptions.updateCustomPriceText = function (personalizationPrice, isModal) {
                        if (
                            customilyWordpress.priceOptions.finalContainer &&
                            customilyWordpress.priceOptions.finalContainer.length
                        ) {
                            customilyWordpress.priceOptions.finalContainer.remove();
                        }

                        const originalContainer = customilyWordpress.priceOptions.getOriginalContainer();
                        customilyWordpress.priceOptions.originalContainer = originalContainer.first();
                        customilyWordpress.priceOptions.originalContainer.removeClass("cl-original-price").removeClass("cl-product-page");

                        var originalPrice = 0.00,
                            finalPrice = 0.00;

                        if (customilyWordpress.priceOptions.originalContainer.length) {
                            customilyWordpress.priceOptions.finalContainer = customilyWordpress.priceOptions.originalContainer.clone();
                            customilyWordpress.priceOptions.finalContainer.addClass("cl-final-price")
                                .insertAfter(customilyWordpress.priceOptions.originalContainer)
                                .css("margin-top", customilyWordpress.priceOptions.originalContainer.css("margin-top"))
                                .css("margin-bottom", customilyWordpress.priceOptions.originalContainer.css("margin-bottom"))
                                .removeClass("hidden");
                            customilyWordpress.priceOptions.originalContainer
                                .addClass("cl-product-page")
                                .addClass("cl-original-price")
                                .addClass("hidden");

                            originalPrice = customilyWordpress.priceOptions.getBasePrice(
                                customilyWordpress.priceOptions.originalContainer
                            );
                            finalPrice = parseFloat(`${originalPrice}`) + parseFloat(`${personalizationPrice}`);
                            finalPrice = finalPrice.toFixed(parseInt(customilyWordpress.priceOptions.decimalCount));

                            if (customilyWordpress.priceOptions.decimalSeparator == ",") {
                                finalPrice = finalPrice.replace(".", ",");
                            }
                            if (customilyWordpress.priceOptions.thousandSeparator) {
                                finalPrice = finalPrice.replace(
                                    /\B(?=(\d{3})+(?!\d))/g,
                                    customilyWordpress.priceOptions.thousandSeparator
                                );
                            }
                            switch (customilyWordpress.priceOptions.currencyPosition) {
                                case "left_space":
                                    finalPrice = `${customilyWordpress.priceOptions.currencySymbol} ${finalPrice}`;
                                    break;
                                case "right_space":
                                    finalPrice += ` ${customilyWordpress.priceOptions.currencySymbol}`;
                                    break;
                                case "right":
                                    finalPrice += customilyWordpress.priceOptions.currencySymbol;
                                    break;
                                default:
                                    finalPrice = customilyWordpress.priceOptions.currencySymbol + finalPrice;
                                    break;
                            }
                            customilyWordpress.priceOptions.finalContainer.html(finalPrice);
                        }

                        if (isModal) {
                            customilyWordpress.priceOptions.modalOriginalContainer = $(".customily-modal-container .cl-original-price");
                            if (!customilyWordpress.priceOptions.modalOriginalContainer.length) {
                                customilyWordpress.priceOptions.modalOriginalContainer = $(".customily-modal-container .price bdi");
                            }

                            customilyWordpress.priceOptions.modalOriginalContainer.removeClass("cl-original-price");

                            if (
                                customilyWordpress.priceOptions.modalFinalContainer &&
                                customilyWordpress.priceOptions.modalFinalContainer.length
                            ) {
                                customilyWordpress.priceOptions.modalFinalContainer.remove();
                            }
                            if (customilyWordpress.priceOptions.modalOriginalContainer.length) {
                                customilyWordpress.priceOptions.modalFinalContainer = customilyWordpress.priceOptions.modalOriginalContainer.clone();
                                customilyWordpress.priceOptions.modalFinalContainer.addClass("cl-final-price")
                                    .insertAfter(customilyWordpress.priceOptions.modalOriginalContainer)
                                    .removeClass("hidden");
                                customilyWordpress.priceOptions.modalOriginalContainer
                                    .addClass("cl-original-price")
                                    .addClass("hidden");
                                customilyWordpress.priceOptions.modalFinalContainer.html(finalPrice);
                            }
                        }
                    };
                });
            });
        }

        if (
            customilyWordpress &&
            (
                customilyWordpress.productConnected == "y" ||
                (customilyWordpress.product && customilyWordpress.product.connected == "y")
            )
        ) {
            const timeout = customilyWordpress.waitForAppStartLoad || 15000;
            setTimeout(function () {
                const pageReloaded = localStorage.getItem("PageReloaded");
                if (!customilyWordpress.appLoading && !pageReloaded) {
                    localStorage.setItem("PageReloaded", "YES");
                    console.log(`Customily Wordpress: App is not loading after ${timeout} seconds, reloading page.`);
                    window.location.reload();
                } else {
                    localStorage.removeItem("PageReloaded");
                }
            }, timeout);

            if (
                customilyWordpress.buttons &&
                customilyWordpress.buttons.disabledUntilAppLoad
            ) {
                var button = document.getElementById("customily-cart-btn");
                if (!button) {
                    button = document.getElementById("customily-quote-btn");
                }
                if (!button) {
                    button = document.getElementById("customily-personalize-button");
                }
                if (!button) {
                    window.dispatchEvent(createCustomEvent("customily-disable-add-to-cart-btn"));
                }
            }
        }
    '
);