const CUSTOMILY_LOCAL_THUMBS_KEY = 'customily-wordpress-thumb';
const MAX_THUMB_AGE_MILLISECONDS = 60 * 60 * 24 * 10 * 1000; // 10 days

function imageExists(url) {
    const http = new XMLHttpRequest();
    http.open('HEAD', url, false);
    http.send();
    return http.status < 400;
}

function getItemFromLocalStorage(thumbId) {
    return JSON.parse(
        localStorage.getItem(`${CUSTOMILY_LOCAL_THUMBS_KEY}-${thumbId.replace('_thumb-id-', '')}`) || ''
    );
}

function removeOldThumbs() {
    const keys = Object.keys(localStorage);
    keys.forEach(function (key) {
        if (key.includes(CUSTOMILY_LOCAL_THUMBS_KEY)) {
            try {
                const thumb = JSON.parse(localStorage.getItem(key) || '');
                if (thumb && Date.now() - thumb.timestamp > MAX_THUMB_AGE_MILLISECONDS) {
                    localStorage.removeItem(`${CUSTOMILY_LOCAL_THUMBS_KEY}-${thumb.id}`);
                }
            } catch (e) {
                console.error(e);
            }
        }
    });
}

window.addEventListener('load', function () {
    const thumbnails = [].slice.call(document.querySelectorAll('[data-thumb-id]'));
    thumbnails.forEach(function (thumbnail) {
        if (thumbnail.src.indexOf('data:image/png;base64,') !== -1 && !imageExists(thumbnail.src)) {
            const thumb = getItemFromLocalStorage(thumbnail.getAttribute('data-thumb-id'));
            if (thumb) {
                thumbnail.src = thumb.image;
            }
        }
    });
});

console.log('Customily Wordpress: running cart script functionality');
removeOldThumbs();